-- phpMyAdmin SQL Dump
-- version 4.9.4
-- https://www.phpmyadmin.net/
--
-- Generation Time: Jun 12, 2020 at 06:01 PM
-- Server version: 10.3.22-MariaDB-0+deb10u1
-- PHP Version: 7.3.6

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";

--
-- Database: `homecontrol`
--

-- --------------------------------------------------------

--
-- Table structure for table `commands`
--

CREATE TABLE `commands` (
  `deviceId` int(50) NOT NULL,
  `id` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `carrierType` int(11) NOT NULL,
  `signalName` varchar(50) NOT NULL,
  `commandType` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `deviceGroups`
--

CREATE TABLE `deviceGroups` (
  `id` int(11) NOT NULL,
  `name` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `deviceGroupsMembers`
--

CREATE TABLE `deviceGroupsMembers` (
  `deviceGroupId` int(11) NOT NULL,
  `deviceId` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `devices`
--

CREATE TABLE `devices` (
  `roomid` int(11) NOT NULL,
  `id` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `housecode` varchar(5) DEFAULT NULL,
  `unitcode` varchar(1) DEFAULT NULL,
  `state` tinyint(2) NOT NULL,
  `protectedStatus` tinyint(2) NOT NULL DEFAULT 0,
  `carrierCapabilities` varchar(50) NOT NULL COMMENT 'carrierTypeRadio433 = 0, carrierTypeInfrared = 1, carrierTypeOrviboS20 = 2, carrierTypeAnelPowerline = 3, carrierTypeNetIOPowerline = 4, carrierTypeTpLinkHs110 = 5, carrierTypeSamsungSmartTv = 6, carrierTypeTpLinkHs100 = 7',
  `macAddress` varchar(50) DEFAULT NULL,
  `ipAddress` varchar(200) DEFAULT NULL,
  `username` varchar(50) DEFAULT NULL,
  `password` varchar(50) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `environment`
--

CREATE TABLE `environment` (
  `sensorid` int(11) NOT NULL,
  `timestamp` bigint(11) NOT NULL,
  `valueType` int(11) NOT NULL,
  `value` double NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `houses`
--

CREATE TABLE `houses` (
  `id` int(11) NOT NULL,
  `name` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `latitude` double DEFAULT NULL,
  `longitude` double DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `nodes`
--

CREATE TABLE `nodes` (
  `id` int(11) NOT NULL,
  `name` varchar(20) NOT NULL,
  `networkNameOrAddress` varchar(50) NOT NULL,
  `relayPort` int(11) NOT NULL,
  `roomid` int(11) NOT NULL,
  `masterNode` tinyint(2) NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `rooms`
--

CREATE TABLE `rooms` (
  `id` int(11) NOT NULL,
  `name` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `houseid` int(11) NOT NULL,
  `lightLevel` int(11) DEFAULT NULL,
  `lightLevelLastUpdate` bigint(20) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `rule-actions`
--

CREATE TABLE `rule-actions` (
  `ruleId` int(11) NOT NULL,
  `executionOrder` int(11) NOT NULL,
  `objectType` enum('device','deviceGroup','command','switchRoom','switchAll','temperature','blinds','wait','application','pushNotification') NOT NULL,
  `object` varchar(400) DEFAULT NULL,
  `value` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `rule-triggers`
--

CREATE TABLE `rule-triggers` (
  `ruleId` int(11) NOT NULL,
  `objectType` enum('brightness','humidity','temperature','users','motion','dateTime','application','powerUsage','doorWindow','waterLeakage','smokeDetector') NOT NULL,
  `object` varchar(250) NOT NULL,
  `direction` enum('eq','lt','ht','le','he','ne') NOT NULL,
  `value` double NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `rules`
--

CREATE TABLE `rules` (
  `id` int(11) NOT NULL,
  `name` varchar(150) NOT NULL,
  `activated` tinyint(2) NOT NULL DEFAULT 1,
  `comment` varchar(200) DEFAULT NULL,
  `lastExecutionTimestamp` bigint(20) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `sensors`
--

CREATE TABLE `sensors` (
  `id` int(11) NOT NULL,
  `name` varchar(200) NOT NULL,
  `active` tinyint(2) NOT NULL DEFAULT 1,
  `roomid` int(11) NOT NULL,
  `responsiblenode` int(11) NOT NULL,
  `sensortype` int(11) NOT NULL COMMENT '1 = motion, 2 = temperature/humidity, 4 = brightness, 5 = button, 6 = power, 7 = binary',
  `interfaceType` enum('local','zigbee2mqtt','ttn','mqtt','derived','hcnetwork') NOT NULL COMMENT 'local, zigbee2mqtt, ttn, mqtt, derived',
  `parameters` varchar(50) DEFAULT NULL,
  `frequency` int(11) DEFAULT NULL,
  `pinOrAddress` varchar(50) NOT NULL,
  `direction` varchar(10) DEFAULT NULL,
  `lastActivity` bigint(20) DEFAULT NULL,
  `lastRawOutput` varchar(1000) DEFAULT NULL,
  `otherData` varchar(500) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `settings`
--

CREATE TABLE `settings` (
  `settingName` varchar(50) NOT NULL,
  `settingValue` varchar(200) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `userdevices`
--

CREATE TABLE `userdevices` (
  `id` int(11) NOT NULL,
  `userid` int(11) NOT NULL,
  `devicename` varchar(100) NOT NULL,
  `devicekey` varchar(200) NOT NULL,
  `encryptionKey` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE `users` (
  `id` int(11) NOT NULL,
  `username` varchar(20) NOT NULL,
  `password` varchar(200) DEFAULT NULL,
  `emailAddress` varchar(80) NOT NULL,
  `useridentifier` varchar(50) NOT NULL,
  `location` int(11) DEFAULT NULL,
  `lastUpdate` bigint(11) DEFAULT NULL,
  `fullName` varchar(200) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Indexes for dumped tables
--

--
-- Indexes for table `commands`
--
ALTER TABLE `commands`
  ADD PRIMARY KEY (`id`),
  ADD KEY `deviceId` (`deviceId`);

--
-- Indexes for table `deviceGroups`
--
ALTER TABLE `deviceGroups`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `deviceGroupsMembers`
--
ALTER TABLE `deviceGroupsMembers`
  ADD PRIMARY KEY (`deviceGroupId`,`deviceId`),
  ADD KEY `deviceId` (`deviceId`);

--
-- Indexes for table `devices`
--
ALTER TABLE `devices`
  ADD PRIMARY KEY (`id`),
  ADD KEY `roomid` (`roomid`);

--
-- Indexes for table `environment`
--
ALTER TABLE `environment`
  ADD PRIMARY KEY (`sensorid`,`timestamp`,`valueType`) USING BTREE;

--
-- Indexes for table `houses`
--
ALTER TABLE `houses`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`),
  ADD UNIQUE KEY `name_2` (`name`);

--
-- Indexes for table `nodes`
--
ALTER TABLE `nodes`
  ADD PRIMARY KEY (`id`),
  ADD KEY `roomid` (`roomid`);

--
-- Indexes for table `rooms`
--
ALTER TABLE `rooms`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`),
  ADD KEY `houseid` (`houseid`);

--
-- Indexes for table `rule-actions`
--
ALTER TABLE `rule-actions`
  ADD PRIMARY KEY (`ruleId`,`executionOrder`);

--
-- Indexes for table `rule-triggers`
--
ALTER TABLE `rule-triggers`
  ADD PRIMARY KEY (`ruleId`,`objectType`,`object`);

--
-- Indexes for table `rules`
--
ALTER TABLE `rules`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `sensors`
--
ALTER TABLE `sensors`
  ADD PRIMARY KEY (`id`),
  ADD KEY `responsiblenode` (`responsiblenode`),
  ADD KEY `roomid` (`roomid`);

--
-- Indexes for table `settings`
--
ALTER TABLE `settings`
  ADD PRIMARY KEY (`settingName`);

--
-- Indexes for table `userdevices`
--
ALTER TABLE `userdevices`
  ADD PRIMARY KEY (`id`),
  ADD KEY `userid` (`userid`);

--
-- Indexes for table `users`
--
ALTER TABLE `users`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `useridentifier` (`useridentifier`),
  ADD UNIQUE KEY `username` (`username`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `commands`
--
ALTER TABLE `commands`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `deviceGroups`
--
ALTER TABLE `deviceGroups`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `devices`
--
ALTER TABLE `devices`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `houses`
--
ALTER TABLE `houses`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `nodes`
--
ALTER TABLE `nodes`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `rooms`
--
ALTER TABLE `rooms`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `rules`
--
ALTER TABLE `rules`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `sensors`
--
ALTER TABLE `sensors`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `userdevices`
--
ALTER TABLE `userdevices`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- AUTO_INCREMENT for table `users`
--
ALTER TABLE `users`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

--
-- Constraints for dumped tables
--

--
-- Constraints for table `commands`
--
ALTER TABLE `commands`
  ADD CONSTRAINT `commands_ibfk_2` FOREIGN KEY (`deviceId`) REFERENCES `devices` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `deviceGroupsMembers`
--
ALTER TABLE `deviceGroupsMembers`
  ADD CONSTRAINT `deviceGroupsMembers_ibfk_1` FOREIGN KEY (`deviceGroupId`) REFERENCES `deviceGroups` (`id`),
  ADD CONSTRAINT `deviceGroupsMembers_ibfk_2` FOREIGN KEY (`deviceId`) REFERENCES `devices` (`id`);

--
-- Constraints for table `devices`
--
ALTER TABLE `devices`
  ADD CONSTRAINT `devices_ibfk_1` FOREIGN KEY (`roomid`) REFERENCES `rooms` (`id`);

--
-- Constraints for table `environment`
--
ALTER TABLE `environment`
  ADD CONSTRAINT `environment_ibfk_1` FOREIGN KEY (`sensorid`) REFERENCES `sensors` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `nodes`
--
ALTER TABLE `nodes`
  ADD CONSTRAINT `nodes_ibfk_1` FOREIGN KEY (`roomid`) REFERENCES `rooms` (`id`);

--
-- Constraints for table `rooms`
--
ALTER TABLE `rooms`
  ADD CONSTRAINT `rooms_ibfk_1` FOREIGN KEY (`houseid`) REFERENCES `houses` (`id`);

--
-- Constraints for table `rule-actions`
--
ALTER TABLE `rule-actions`
  ADD CONSTRAINT `rulefk` FOREIGN KEY (`ruleId`) REFERENCES `rules` (`id`);

--
-- Constraints for table `rule-triggers`
--
ALTER TABLE `rule-triggers`
  ADD CONSTRAINT `ruleidfk` FOREIGN KEY (`ruleId`) REFERENCES `rules` (`id`);

--
-- Constraints for table `sensors`
--
ALTER TABLE `sensors`
  ADD CONSTRAINT `sensors_ibfk_1` FOREIGN KEY (`roomid`) REFERENCES `rooms` (`id`),
  ADD CONSTRAINT `sensors_ibfk_2` FOREIGN KEY (`responsiblenode`) REFERENCES `nodes` (`id`);

--
-- Constraints for table `userdevices`
--
ALTER TABLE `userdevices`
  ADD CONSTRAINT `userdevices_ibfk_1` FOREIGN KEY (`userid`) REFERENCES `users` (`id`);
COMMIT;

