#!/usr/bin/python
 
import spidev
import time
import os
import sys

light_channel = int('0')

for eachArg in sys.argv[1:]:
  light_channel = int(eachArg)

 
# Open SPI bus
spi = spidev.SpiDev()
spi.open(0,0)

vRef = 3.3
 
# Function to read SPI data from MCP3008 chip
# Channel must be an integer 0-7
def ReadChannel(channel):
  adc = spi.xfer2([1,(8+channel)<<4,0])
  print("adc: " + str(adc))

  data = ((adc[1]&3) << 8) + adc[2]
  print("data: " + str(data))
  return data
 
# Function to convert data to voltage level,
# rounded to specified number of decimal places.
def ConvertVolts(data,places):
  volts = (data * vRef) / float(1023)
  print("volts1: " + str(volts))
  volts = round(volts,places)
  print("volts2: " + str(volts))
  return volts
 
# Read the light sensor data
light_level = ReadChannel(light_channel)
 
# Print out results
print(str(light_level) + "/1023")
